{ Composant TSystemMenu version 1.2 (15/12/97)
  Par CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain (portions par Jean-Luc Mattei)
  cresto@mygale.org
  http://www.mygale.org/~cresto/
  La Borde / 09230 / Contrazy / France
    ----

  Composant pour Delphi 1.0, 2.0, 3.0x et C++ Builder 1.0.

  Ce composant vous permet de modifier le menu systme de votre application.

  Nouveau avec la version 1.1: Correction de bugs causs par des fentres MDI et
  compatibilit avec Delphi 1.0.
    ----

  Ce composant est un FREEWARE, vous pouvez l'utiliser dans tous vos
  programmes (commerciaux ou pas !) et les distribuer sans rien me devoir.
  Vous utilisez ce composant  vos risques et prils.
  Par contre vous * NE DEVEZ PAS * distribuer le code source * MODIFI *
  de ce composant sans avoir eu au pralable mon accord.
                                                       Merci.


  -------------

  TSystemMenu component version 1.2 (12/15/97)
  Par CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain (portions by Jean-Luc Mattei)
  cresto@mygale.org
  http://www.mygale.org/~cresto/
  La Borde / 09230 / Contrazy / France
    ----

  For Delphi 1.0, 2.0, 3.0x and C++ Builder 1.0

  This component allows you to change the system menu (also known as control menu) of
  your application.

  New with 1.1: Works with Delphi 1.0 and MDI windows.
    ----

  This component is FREEWARE!
  No warranty is given by the author, expressed or implied.
  Do not distribute modified version without my agreement.
                                                       thanks.


}


unit SysMenu;

interface

uses
  {$ifdef win32}
  Windows,
  {$else}
  WinProcs, WinTypes,
  {$endif}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Menus, DsgnIntf;

type
  TAboutProperty = class(TPropertyEditor)
  private
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;
  TSystemMenu = class(TComponent)
  private
    FAbout:TAboutProperty;
    FSystemMenu:TPopupMenu;
    SubCommand:array[1..20] of Integer;
    CountSub:Byte;
    aOwnerHandle:Integer;
    FTPUHandle:THandle;
    FNewTFormWndProcInstance:Pointer;
    FOldTFormWndProc:Pointer;
    FNewTFormMDIClientWndProcInstance:Pointer;
    FOldTFormMDIClientWndProc:Pointer;
    procedure SetSystemMenu(value:TPopupMenu);
    procedure AddMenu(menu:TMenuitem;handle:Integer);
  public
    constructor Create(aOwner:TComponent); override;
    destructor Destroy; override;
    procedure NewTFormWndProc(var Message:TMessage);
    procedure NewTFormMDIClientWndProc(var Message:TMessage);
  published
    property About : TAboutProperty read FAbout write FAbout;
    property SystemMenu : TPopupMenu read FSystemMenu write SetSystemMenu;
  end;

procedure Register;

{$ifdef win32}
{$R SYSMENU.RES}
{$else}
{$R SYSME16.RES}
{$endif}

implementation

const FTPUCount:Integer=0;

procedure Register;
begin
  RegisterComponents('CRESOFT', [TSystemMenu]);
  RegisterPropertyEditor(TypeInfo(TAboutProperty), TSystemMenu, 'ABOUT', TAboutProperty);
end;


{ TSystemMenu }

constructor TSystemMenu.Create(aOwner : Tcomponent);
begin
  inherited create(aOwner);
  aOwnerHandle:=tform(aOwner).handle;
  CountSub:=0;
  FSystemMenu:=nil;
  if not (csDesigning in ComponentState) then
  begin
    if (AOwner is TForm) then
    begin
      FNewTFormWndProcInstance:=MakeObjectInstance(NewTFormWndProc);
      FOldTFormWndProc:=Pointer(GetWindowLong((Owner as TForm).Handle,GWL_WNDPROC));
      SetWindowLong((Owner as TForm).Handle,GWL_WNDPROC,Longint(FNewTFormWndProcInstance));
    end;
  end;
end;

destructor TSystemMenu.Destroy;
begin
  if not (csDesigning in ComponentState) then
  begin
    if Owner is TForm then
    begin
      SetWindowLong(FTPUHandle, GWL_WNDPROC, Longint(FOldTFormWndProc));
      FreeObjectInstance(FNewTFormWndProcInstance);
      if ((Owner as TForm).FormStyle=fsMDIForm) then
      begin
        SetWindowLong(FTPUHandle, GWL_WNDPROC, Longint(FOldTFormMDIClientWndProc));
        FreeObjectInstance(FNewTFormMDIClientWndProcInstance);
      end;
    end;
  end;
  inherited Destroy;
end;

procedure TSystemMenu.NewTFormWndProc(Var Message: TMessage);
  var menu:tmenuitem;
      c,handle:integer;
begin
  if FSystemMenu<>nil then
    case Message.Msg of
      wm_syscommand: begin
                     menu:=FSystemMenu.finditem(Message.wparam,fkcommand);
                     if menu<>nil then menu.click;
                   end;
      wm_initmenu: begin
                     handle:=getsystemmenu(aOwnerHandle,false);
                     if FSystemMenu.items.count>0 then
                     begin
                       for c:=0 to FSystemMenu.items.count-1 do deletemenu(handle,FSystemMenu.items[c].command,mf_bycommand);
                       if countsub>0 then for c:=1 to countsub do deletemenu(handle,subcommand[countsub],mf_bycommand);
                     end;
                     countsub:=0;
                     addmenu(FSystemMenu.items,handle);
                   end;
    end;
  Message.Result:=CallWindowProc(FOldTFormWndProc,(Owner as TForm).Handle,Message.Msg,Message.WParam,Message.LParam);
end;

procedure TSystemMenu.NewTFormMDIClientWndProc(Var Message: TMessage);
  var menu:tmenuitem;
      c,handle:integer;
begin
  if FSystemMenu<>nil then
    case Message.Msg of
      wm_syscommand: begin
                     menu:=FSystemMenu.finditem(Message.wparam,fkcommand);
                     if menu<>nil then menu.click;
                   end;
      wm_initmenu: begin
                     handle:=getsystemmenu(aOwnerHandle,false);
                     if FSystemMenu.items.count>0 then
                     begin
                       for c:=0 to FSystemMenu.items.count-1 do deletemenu(handle,FSystemMenu.items[c].command,mf_bycommand);
                       if countsub>0 then for c:=1 to countsub do deletemenu(handle,subcommand[countsub],mf_bycommand);
                     end;
                     countsub:=0;
                     addmenu(FSystemMenu.items,handle);
                   end;
    end;
  Message.Result:=CallWindowProc(FOldTFormMDIClientWndProc,(Owner as TForm).Handle,Message.Msg,Message.WParam,Message.LParam);
end;

procedure TSystemMenu.SetSystemMenu(value:TPopupMenu);
begin
  FSystemMenu:=value;
end;

procedure TSystemMenu.AddMenu(menu:TMenuItem;handle:Integer);
 var h,c:integer; flags:integer;
     {$ifndef Win32}
     tmp:pchar;
     {$endif}
begin
  if menu.count>0 then
  for c:=0 to menu.count-1 do
  begin
    if menu.items[c].caption<>'-' then
    begin
      if menu.items[c].count=0 then
      begin
        if menu.items[c].visible then
        begin
          flags:=mf_string;
          if menu.items[c].checked then flags:=flags+mf_checked;
          if menu.items[c].enabled=false then flags:=flags+mf_grayed;
          if menu.items[c].break=mbbreak then flags:=flags+mf_menubreak;
          if menu.items[c].break=mbbarbreak then flags:=flags+mf_menubarbreak;

          {$ifdef Win32}
          appendmenu(handle,flags,menu.items[c].command,pchar(menu.items[c].caption+#9+
                     ShortCutToText(menu.items[c].shortcut)));
          {$else}
          tmp:=stralloc(length(menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut)));
          strpcopy(tmp,menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut));
          appendmenu(handle,flags,menu.items[c].command,tmp);
          strdispose(tmp);
          {$endif}

        end;
      end else
      begin
        h:=createpopupmenu;
        addmenu(menu.items[c],h);

        {$ifdef Win32}
        appendmenu(handle,mf_popup,h,pchar(menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut)));
        {$else}
        tmp:=stralloc(length(menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut)));
        strpcopy(tmp,menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut));
        appendmenu(handle,mf_popup,h,tmp);
        strdispose(tmp);
        {$endif}

        countsub:=countsub+1;
        subcommand[countsub]:=h;
      end;
    end
    else appendmenu(handle,mf_separator,menu.items[c].command,nil);
  end;
end;

{ TAboutProperty }

procedure TAboutProperty.Edit;
begin
  Application.MessageBox('By CRESTO Sylvain - 1997'#13+
    'This component (for Delphi 1.0, 2.0, 3.0x and C++ Builder 1.0) is FREEWARE.'#13#13+
    'E-Mail : cresto@mygale.org'#13'WEB : http://www.mygale.org/~cresto/',
    'SystemMenu component version 1.1', MB_OK+ MB_ICONINFORMATION);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  GetAttributes:=[paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
  GetValue:='(About)';
end;


end.
